/***********************************************************************************************************************
* DISCLAIMER
* This software is supplied by Renesas Electronics Corporation and is only intended for use with Renesas products.
* No other uses are authorized. This software is owned by Renesas Electronics Corporation and is protected under all
* applicable laws, including copyright laws. 
* THIS SOFTWARE IS PROVIDED "AS IS" AND RENESAS MAKES NO WARRANTIES REGARDING THIS SOFTWARE, WHETHER EXPRESS, IMPLIED
* OR STATUTORY, INCLUDING BUT NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
* NON-INFRINGEMENT.  ALL SUCH WARRANTIES ARE EXPRESSLY DISCLAIMED.TO THE MAXIMUM EXTENT PERMITTED NOT PROHIBITED BY
* LAW, NEITHER RENESAS ELECTRONICS CORPORATION NOR ANY OF ITS AFFILIATED COMPANIES SHALL BE LIABLE FOR ANY DIRECT,
* INDIRECT, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES FOR ANY REASON RELATED TO THIS SOFTWARE, EVEN IF RENESAS OR
* ITS AFFILIATES HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
* Renesas reserves the right, without notice, to make changes to this software and to discontinue the availability 
* of this software. By using this software, you agree to the additional terms and conditions found by accessing the 
* following link:
* http://www.renesas.com/disclaimer
*
* Copyright (C) 2011, 2019 Renesas Electronics Corporation. All rights reserved.
***********************************************************************************************************************/

/***********************************************************************************************************************
* File Name    : r_main.c
* Version      : CodeGenerator for RL78/G13 V2.05.04.02 [20 Nov 2019]
* Device(s)    : R5F100LE
* Tool-Chain   : CCRL
* Description  : This file implements main function.
* Creation Date: 21-1-19
***********************************************************************************************************************/

/***********************************************************************************************************************
Includes
***********************************************************************************************************************/
#include "../r_cg_macrodriver.h"
#include "../r_cg_cgc.h"
#include "../r_cg_port.h"
//#include "../r_cg_intc.h"
#include "../r_cg_serial.h"
#include "../r_cg_timer.h"
/* Start user code for include. Do not edit comment generated here */
/***********************************************************************************************************************
* Device Configuration
* --------------------
* DBG_COM @ 115200bps
* BT @ 115200bps
*
* TODO:
* -----
*
*
*
*
*
***********************************************************************************************************************/
//#include "typedef.h"
#include "r_typedefs.h"
//#include "r_cg_timer.h"
//#include "r_cg_serial.h"
#include "fsl.h"
#include "fsl_types.h"
#include "r_xmodem.h"
#include "crc16.h"
#include "user_def.h"
/* End user code. Do not edit comment generated here */
#include "r_cg_userdefine.h"

/***********************************************************************************************************************
Pragma directive
***********************************************************************************************************************/
/* Start user code for pragma. Do not edit comment generated here */
/* End user code. Do not edit comment generated here */

/***********************************************************************************************************************
Global variables and functions
***********************************************************************************************************************/
/* Start user code for global. Do not edit comment generated here */
#define PRODUCTION_PROGRAM_REV_MAJOR   0
#define PRODUCTION_PROGRAM_REV_MINOR   1

typedef enum
{
	FSL_INIT,
	FSL_ERASE,
	FSL_WRITE,
	FSL_INVERTBOOTFLAG
} error_handler_case;

void ErrorHandler(uint8_t case_num);
void delay(uint32_t delay_time);
void Boot_R_TAU0_Create(void);
void Boot_R_TAU0_Channel0_Start(void);
void Boot_R_TAU0_Channel0_Stop(void);
void boot_hdwinit(void);
void Boot_R_CGC_Create(void);
void Boot_R_PORT_Create(void);
void Boot_R_SAU0_Create(void);
void Boot_R_UART1_Create(void);
void Boot_R_UART1_Start(void);
extern fsl_u08 WriteFlash(uint16_t addr, int8_t data[], uint8_t size);
void R_UART1_Send_String(__far int8_t buffer[]);
void R_UART1_Send_Byte(int8_t data);
//unsigned short		CRC_wj_rom,CRC_bit_rom,CRC_init_rom;	//WangJin 2021.02.01
//unsigned short		CRC_wj_ccitt, CRC_bit_ccitt, CRC_init_ccitt;


void boot_main(void)
{
	uint16_t 	i = 0;
  int8_t 		selection;
  int8_t 		reselect = 1;
  fsl_u08 	fsl_status;
  __far fsl_descriptor_t 	fsl_descr;
	uint8_t		ret;
	uint16_t	flag_start = 0xFFFF;
	uint16_t	flag_end = 0xFFFF;
	uint16_t	flag_start_end = 0xFFFF;
	unsigned short		CRC_rom, CRC_ccitt;	//WangJin 2021.02.01
	uint8_t			OTA_FLAG_START[4] = {0xAA,0xFF,0xFF,0xFF};
	uint8_t			OTA_FLAG_END[4] = {0x55,0xFF,0xFF,0xFF};
	
    /* Start user code. Do not edit comment generated here */
//	EI();		WangJin 2021.01.20
//start: only for test by hh 2022.08.08
	CRC_ccitt = *(__far unsigned int *)CRC_ADDRESS;
	CRC_rom = calcrc(FLASH_AREA, (CRC_ADDRESS - FLASH_AREA));		//0x2000 - 0xFBF3
//end: only for test
    /****************/
    /* Boot Program */
    /****************/
    Boot_R_UART1_Start();
            
	/* initialize self-programming environment */
	fsl_descr.fsl_flash_voltage_u08 = 0x00;
	fsl_descr.fsl_frequency_u08 = 0x08;
	fsl_descr.fsl_auto_status_check_u08 = 0x01;
	
	fsl_status = FSL_Init(&fsl_descr);
	
	if(fsl_status != FSL_OK)
	{
		ErrorHandler(FSL_INVERTBOOTFLAG);
	}
	
	FSL_Open();
	FSL_PrepareFunctions();
	FSL_PrepareExtFunctions();

	/* Print operation menu */

#if 1
	R_UART1_Send_String((__far int8_t*)"\n\r*** FW Ver.: 1.5  old ***\n\r");
#else
	R_UART1_Send_String((__far int8_t*)"\n\r*** FW Ver.: 1.6  new ***\n\r");
#endif


	while (1){
		R_UART1_Send_String((__far int8_t*)"\n\rChoose actions:(1)Update Boot area + App area (2)Update App area only\n\r");
/*
		while (1){
			WDTE = 0xAC;
			if (GetByte(1000, &selection)) break;
		}
		*/
		if (FALSE == GetByte(5000,  &selection)) break;
#if 0 // only for test FSL  ****start
		NOP();
		NOP();
		
		for (i = 4; i < FLASH_END_BLOCK; i++) 
		{
			fsl_status = FSL_Erase(i);
			if (fsl_status != FSL_OK)
			{
				ErrorHandler(FSL_ERASE);
			}
		}
				
		if( FSL_OK != WriteFlash(OTA_FLAG_START_ADDRESS, (int8_t*)OTA_FLAG_START, 4))
		{
			ErrorHandler(FSL_ERASE);
		}
		while(1);
#endif // only for test FSL ****end
		switch (selection){
			case '1':
				R_UART1_Send_String((__far int8_t*)"\n\rSelect file to write into flash area.");
                                    
				for (i = 4; i < FLASH_END_BLOCK; i++) 
				{
					fsl_status = FSL_Erase(i);
					if (fsl_status != FSL_OK)
					{
						ErrorHandler(FSL_ERASE);
					}
				}
				
				if( FSL_OK != WriteFlash(OTA_FLAG_START_ADDRESS, (int8_t*)OTA_FLAG_START, 4))
				{
					ErrorHandler(FSL_ERASE);
				}
				
				fsl_status = XmodemProg(BOOT_AREA);

				if(fsl_status == XM_OK)
				{
					CRC_ccitt = *(__far unsigned int *)CRC_ADDRESS;
					CRC_rom = calcrc(FLASH_AREA, (CRC_ADDRESS - FLASH_AREA));
					
					if( CRC_ccitt == CRC_rom )
					{
						if( FSL_OK == WriteFlash(OTA_FLAG_END_ADDRESS, (int8_t*)OTA_FLAG_END, 4) )
						{
							R_UART1_Send_String((__far int8_t*)"\n\rUpdate boot area: Succeeded");
							//R_UART1_Send_String((__far int8_t*)"\n\rGoto app.\n\r");
						}
						else
						{
							ErrorHandler(FSL_ERASE);
						}
					}
					else
					{
						R_UART1_Send_String((__far int8_t*)"\n\rCRC NG\n\r");
						FSL_ForceReset();
					}
					fsl_status = FSL_InvertBootFlag();
					if (fsl_status != FSL_OK)
					{
						ErrorHandler(FSL_INVERTBOOTFLAG);
					}
					else
					{
						R_UART1_Send_String((__far int8_t*)"\n\rInvertBootFlag: Succeeded");
					}
				}
				else
				{
					R_UART1_Send_String((__far int8_t*)"\n\rUpdate boot + app area: Failed");
					FSL_ForceReset();
				}
				R_UART1_Send_String((__far int8_t*)"\n\rReset\n\r");
				reselect = 0;
				//FSL_ForceReset();
				break;
			
			case '2':
				R_UART1_Send_String((__far int8_t*)"\n\rPlease select flash.bin file\n\r");

				for (i = FLASH_AREA/FLASH_BYTE_PER_BLOCK; i < FLASH_END_BLOCK; i++)
				{
					fsl_status = FSL_Erase(i);
					if (fsl_status != FSL_OK)
					{
						ErrorHandler(FSL_ERASE);
					}
				}
				
				if( FSL_OK != WriteFlash(OTA_FLAG_START_ADDRESS, (int8_t*)OTA_FLAG_START, 4))
//				if( FSL_OK != WriteFlash(OTA_FLAG_END_ADDRESS, (int8_t*)OTA_FLAG_START, 4))
//				if( FSL_OK != WriteFlash(CRC_ADDRESS, (int8_t*)OTA_FLAG_START, 4))
				{
					ErrorHandler(FSL_ERASE);
				}
				
				fsl_status = XmodemProg_FlashOnly(FLASH_AREA);

				if(fsl_status == XM_OK)
				{
					CRC_ccitt = *(__far unsigned int *)CRC_ADDRESS;
					CRC_rom = calcrc(FLASH_AREA, (CRC_ADDRESS - FLASH_AREA));
					
					if( CRC_ccitt == CRC_rom )
					{
						if( FSL_OK == WriteFlash(OTA_FLAG_END_ADDRESS, (int8_t*)OTA_FLAG_END, 4) )
						{
							R_UART1_Send_String((__far int8_t*)"\n\rUpdate flash area: Succeeded");
							R_UART1_Send_String((__far int8_t*)"\n\rGoto app.\n\r");
							reselect = 0;
						}
						else
						{
							R_UART1_Send_String((__far int8_t*)"\n\rCRC NG\n\r");
							ErrorHandler(FSL_ERASE);
						}
					}
				}
				else
				{
					R_UART1_Send_String((__far int8_t*)"\n\rUpdate flash area: Failed");
					FSL_ForceReset();
//					while (1)
//					{
//						WDTE = 0xAC;
//					}
				}
				break;
			default:
				R_UART1_Send_String((__far int8_t*)"\n\rSelect again.\n\r");
    			reselect = 1;
				break;
			}

		if(reselect == 0)
			return;
    	}
	
		flag_start = *(__far unsigned int *)OTA_FLAG_START_ADDRESS;	//for sample OTA_FLAG_START_ADDRESS= 0xFBF8 [AA]
		flag_end = *(__far unsigned int *)OTA_FLAG_END_ADDRESS;			//for sample OTA_FLAG_END_ADDRESS= 0xFBFC  [55]
		flag_start_end = ((flag_start & 0x00FF) << 8) | (flag_end & 0x00FF);
	
		if( 0xAAFF == flag_start_end ){		//The OTA operation has been started
			for (i = 4; i < FLASH_END_BLOCK; i++)
			{
				fsl_status = FSL_Erase(i);
				if (fsl_status != FSL_OK)
				{
					ErrorHandler(FSL_ERASE);
					//goto loop;
				}
			}
		}
		else if( 0xFFFF == flag_start_end ){	//There has benn no OTA operation launched
			CRC_ccitt = *(__far unsigned int *)CRC_ADDRESS;
			CRC_rom = calcrc(FLASH_AREA, (CRC_ADDRESS - FLASH_AREA));

			if(CRC_rom == CRC_ccitt){	//The image in the flash is available
				R_UART1_Send_String((__far int8_t*)"\n\rjump to 0x2000\n\r");
//				goto jump_to_app;
				return;
			}
			else{						//The image in the flash is unavailable
				R_UART1_Send_String((__far int8_t*)"\n\rimage is damaged\n\r");
				//goto loop;
			}
		}
		else if( 0xAA55 == flag_start_end ){	//The previous OTA operation succeeded
			//goto jump_to_app;
			return;
		}
		else{
			FSL_ForceReset();
		}
    	
    	fsl_status = FSL_BlankCheck(FLASH_AREA/FLASH_BYTE_PER_BLOCK);
    	if (fsl_status == FSL_OK)
    	{
    		R_UART1_Send_String((__far int8_t*)"\n\rThe user program is empty.");
    		delay(3000);
    		//FSL_ForceReset();
    	}
/*
jump_to_app:
	;	*/
	NOP();
}

/*******************************************************************************
* Function Name : ErrorHandler
* Description	: This function handles the error behavior.	
* Parameters	: case_num -
*                    error case number
* Return value  : none
*******************************************************************************/
void ErrorHandler(uint8_t case_num)
{
#if 0
	switch (case_num)
	{
		case FSL_INIT:
			R_UART1_Send_String((__far int8_t*)"\n\r FSL_Init failed");
			break;
		case FSL_ERASE:
			R_UART1_Send_String((__far int8_t*)"\n\r FSL_Erase failed");
			break;
		case FSL_WRITE:
			R_UART1_Send_String((__far int8_t*)"\n\r FSL_Write failed");
			break;
		case FSL_INVERTBOOTFLAG:
			R_UART1_Send_String((__far int8_t*)"\n\r FSL_InvertBootFlag failed");
			break;
	}
#endif
	R_UART1_Send_String((__far int8_t*)"\n\r FSL Operation failed");
	FSL_ForceReset();
//	while (1)
//	{
//		WDTE = 0xAC;
//	}
}

void delay(uint32_t delay_time)
{
	Boot_R_TAU0_Channel0_Start();
	while (delay_time)
	{
		if (TMIF00 == 1)
		{
			WDTE = 0xAC;
			TMIF00 = 0;
			delay_time--;
		}
	}
	Boot_R_TAU0_Channel0_Stop();
}

/***********************************************************************************************************************
* Function Name: R_TAU0_Create
* Description  : This function initializes the TAU0 module.
* Arguments    : None
* Return Value : None
***********************************************************************************************************************/
void Boot_R_TAU0_Create(void)
{
    TAU0EN = 1U;    /* supplies input clock */
    TPS0 = _0000_TAU_CKM0_FCLK_0 | _0000_TAU_CKM1_FCLK_0 | _0000_TAU_CKM2_FCLK_1 | _0000_TAU_CKM3_FCLK_8;
    /* Stop all channels */
    TT0 = _0001_TAU_CH0_STOP_TRG_ON | _0002_TAU_CH1_STOP_TRG_ON | _0004_TAU_CH2_STOP_TRG_ON |
          _0008_TAU_CH3_STOP_TRG_ON | _0010_TAU_CH4_STOP_TRG_ON | _0020_TAU_CH5_STOP_TRG_ON |
          _0040_TAU_CH6_STOP_TRG_ON | _0080_TAU_CH7_STOP_TRG_ON | _0200_TAU_CH1_H8_STOP_TRG_ON |
          _0800_TAU_CH3_H8_STOP_TRG_ON;
    /* Mask channel 0 interrupt */
    TMMK00 = 1U;    /* disable INTTM00 interrupt */
    TMIF00 = 0U;    /* clear INTTM00 interrupt flag */
    /* Mask channel 1 interrupt */
    TMMK01 = 1U;    /* disable INTTM01 interrupt */
    TMIF01 = 0U;    /* clear INTTM01 interrupt flag */
    /* Mask channel 1 higher 8 bits interrupt */
    TMMK01H = 1U;    /* disable INTTM01H interrupt */
    TMIF01H = 0U;    /* clear INTTM01H interrupt flag */
    /* Mask channel 2 interrupt */
    TMMK02 = 1U;    /* disable INTTM02 interrupt */
    TMIF02 = 0U;    /* clear INTTM02 interrupt flag */
    /* Mask channel 3 interrupt */
    TMMK03 = 1U;    /* disable INTTM03 interrupt */
    TMIF03 = 0U;    /* clear INTTM03 interrupt flag */
    /* Mask channel 3 higher 8 bits interrupt */
    TMMK03H = 1U;    /* disable INTTM03H interrupt */
    TMIF03H = 0U;    /* clear INTTM03H interrupt flag */
    /* Mask channel 4 interrupt */
    TMMK04 = 1U;    /* disable INTTM04 interrupt */
    TMIF04 = 0U;    /* clear INTTM04 interrupt flag */
    /* Mask channel 5 interrupt */
    TMMK05 = 1U;    /* disable INTTM05 interrupt */
    TMIF05 = 0U;    /* clear INTTM05 interrupt flag */
    /* Mask channel 6 interrupt */
    TMMK06 = 1U;    /* disable INTTM06 interrupt */
    TMIF06 = 0U;    /* clear INTTM06 interrupt flag */
    /* Mask channel 7 interrupt */
    TMMK07 = 1U;    /* disable INTTM07 interrupt */
    TMIF07 = 0U;    /* clear INTTM07 interrupt flag */
    /* Channel 0 used as interval timer */
    TMR00 = _0000_TAU_CLOCK_SELECT_CKM0 | _0000_TAU_CLOCK_MODE_CKS | _0000_TAU_COMBINATION_SLAVE |
            _0000_TAU_TRIGGER_SOFTWARE | _0000_TAU_MODE_INTERVAL_TIMER | _0000_TAU_START_INT_UNUSED;
    TDR00 = _7CFF_TAU_TDR00_VALUE;
    TO0 &= ~_0001_TAU_CH0_OUTPUT_VALUE_1;
    TOE0 &= ~_0001_TAU_CH0_OUTPUT_ENABLE;
}

/***********************************************************************************************************************
* Function Name: R_TAU0_Channel0_Start
* Description  : This function starts TAU0 channel 0 counter.
* Arguments    : None
* Return Value : None
***********************************************************************************************************************/
void Boot_R_TAU0_Channel0_Start(void)
{
    TS0 |= _0001_TAU_CH0_START_TRG_ON;
}

/***********************************************************************************************************************
* Function Name: R_TAU0_Channel0_Stop
* Description  : This function stops TAU0 channel 0 counter.
* Arguments    : None
* Return Value : None
***********************************************************************************************************************/
void Boot_R_TAU0_Channel0_Stop(void)
{
    TT0 |= _0001_TAU_CH0_STOP_TRG_ON;
}


/***********************************************************************************************************************
* Function Name: boot_hdwinit
* Description  : This function initializes hardware setting.
* Arguments    : None
* Return Value : None
***********************************************************************************************************************/
void boot_hdwinit(void)
{
    DI();
	
	PIOR = 0x00U;
    Boot_R_CGC_Create();
    Boot_R_PORT_Create();
    Boot_R_SAU0_Create();
	Boot_R_TAU0_Create();

    IAWCTL = 0x00U;
}

void Boot_R_CGC_Create(void)
{
	/* Set fMX */
    CMC = _00_CGC_HISYS_PORT | _00_CGC_SUB_PORT | _00_CGC_SYSOSC_DEFAULT | _00_CGC_SUBMODE_DEFAULT;
    MSTOP = 1U;
    /* Set fMAIN */
    MCM0 = 0U;
    /* Set fSUB */
    XTSTOP = 1U;
    OSMC = _10_CGC_RTC_CLK_FIL;
    /* Set fCLK */
    CSS = 0U;
    /* Set fIH */
    HIOSTOP = 0U;
}

/***********************************************************************************************************************
* Function Name: R_PORT_Create
* Description  : This function initializes the Port I/O.
* Arguments    : None
* Return Value : None
***********************************************************************************************************************/
void Boot_R_PORT_Create(void)
{
    PM1 = _01_PMn0_MODE_INPUT | _02_PMn1_NOT_USE | _04_PMn2_NOT_USE | _08_PMn3_NOT_USE | _10_PMn4_NOT_USE |
          _20_PMn5_NOT_USE | _40_PMn6_NOT_USE | _80_PMn7_NOT_USE;
}

/***********************************************************************************************************************
* Function Name: R_SAU0_Create
* Description  : This function initializes the SAU0 module.
* Arguments    : None
* Return Value : None
***********************************************************************************************************************/
void Boot_R_SAU0_Create(void)
{
    SAU0EN = 1U;    /* supply SAU0 clock */
    NOP();
    NOP();
    NOP();
    NOP();
    SPS0 = _0001_SAU_CK00_FCLK_1 | _0010_SAU_CK01_FCLK_1;
    Boot_R_UART1_Create();
}

/***********************************************************************************************************************
* Function Name: R_UART1_Create
* Description  : This function initializes the UART1 module.
* Arguments    : None
* Return Value : None
***********************************************************************************************************************/
void Boot_R_UART1_Create(void)
{
	ST0 |= _0008_SAU_CH3_STOP_TRG_ON | _0004_SAU_CH2_STOP_TRG_ON;    /* disable UART1 receive and transmit */
    STMK1 = 1U;    /* disable INTST1 interrupt */
    STIF1 = 0U;    /* clear INTST1 interrupt flag */
    SRMK1 = 1U;    /* disable INTSR1 interrupt */
    SRIF1 = 0U;    /* clear INTSR1 interrupt flag */
    SREMK1 = 1U;   /* disable INTSRE1 interrupt */
    SREIF1 = 0U;   /* clear INTSRE1 interrupt flag */
    /* Set INTST1 low priority */
    STPR11 = 1U;
    STPR01 = 1U;
    /* Set INTSR1 low priority */
    SRPR11 = 1U;
    SRPR01 = 1U;
    SMR02 = _0020_SAU_SMRMN_INITIALVALUE | _0000_SAU_CLOCK_SELECT_CK00 | _0000_SAU_TRIGGER_SOFTWARE |
            _0002_SAU_MODE_UART | _0000_SAU_TRANSFER_END;
    SCR02 = _8000_SAU_TRANSMISSION | _0000_SAU_INTSRE_MASK | _0000_SAU_PARITY_NONE | _0080_SAU_LSB | _0010_SAU_STOP_1 |
            _0007_SAU_LENGTH_8;
    SDR02 = _8800_UART1_TRANSMIT_DIVISOR;
    NFEN0 |= _04_SAU_RXD1_FILTER_ON;
    SIR03 = _0004_SAU_SIRMN_FECTMN | _0002_SAU_SIRMN_PECTMN | _0001_SAU_SIRMN_OVCTMN;    /* clear error flag */
    SMR03 = _0020_SAU_SMRMN_INITIALVALUE | _0000_SAU_CLOCK_SELECT_CK00 | _0100_SAU_TRIGGER_RXD | _0000_SAU_EDGE_FALL |
            _0002_SAU_MODE_UART | _0000_SAU_TRANSFER_END;
    SCR03 = _4000_SAU_RECEPTION | _0000_SAU_INTSRE_MASK | _0000_SAU_PARITY_NONE | _0080_SAU_LSB | _0010_SAU_STOP_1 |
            _0007_SAU_LENGTH_8;
    SDR03 = _8800_UART1_RECEIVE_DIVISOR;
    SO0 |= _0004_SAU_CH2_DATA_OUTPUT_1;
    SOL0 |= _0000_SAU_CHANNEL2_NORMAL;    /* output level normal */
    SOE0 |= _0004_SAU_CH2_OUTPUT_ENABLE;    /* enable UART1 output */
    /* Set RxD1 pin */
    PMC0 &= 0xF7U;
    PM0 |= 0x08U;
    /* Set TxD1 pin */
    PMC0 &= 0xFBU;
    P0 |= 0x04U;
    PM0 &= 0xFBU;
}

/***********************************************************************************************************************
* Function Name: Boot_R_UART1_Start
* Description  : This function starts the UART1 module operation.
* Arguments    : None
* Return Value : None
***********************************************************************************************************************/
void Boot_R_UART1_Start(void)
{
    SO0 |= _0004_SAU_CH2_DATA_OUTPUT_1;    /* output level normal */
    SOE0 |= _0004_SAU_CH2_OUTPUT_ENABLE;    /* enable UART1 output */
    SS0 |= _0008_SAU_CH3_START_TRG_ON | _0004_SAU_CH2_START_TRG_ON;    /* enable UART1 receive and transmit */
    STIF1 = 0U;    /* clear INTST1 interrupt flag */
    SRIF1 = 0U;    /* clear INTSR1 interrupt flag */
    STMK1 = 0U;    /* enable INTST1 interrupt */
    SRMK1 = 0U;    /* enable INTSR1 interrupt */
}

/***********************************************************************************************************************
* Function Name: R_UART1_Stop
* Description  : This function stops the UART1 module operation.
* Arguments    : None
* Return Value : None
***********************************************************************************************************************/
void Boot_R_UART1_Stop(void)
{
    STMK1 = 1U;    /* disable INTST1 interrupt */
    SRMK1 = 1U;    /* disable INTSR1 interrupt */
    ST0 |= _0008_SAU_CH3_STOP_TRG_ON | _0004_SAU_CH2_STOP_TRG_ON;    /* disable UART1 receive and transmit */
    SOE0 &= ~_0004_SAU_CH2_OUTPUT_ENABLE;    /* disable UART1 output */
    STIF1 = 0U;    /* clear INTST1 interrupt flag */
    SRIF1 = 0U;    /* clear INTSR1 interrupt flag */
   
}

/********************************************************************************
* Function Name: UART0_Send_Byte
* Description  : This function sends UART0 data.
* Arguments    : data - 
*					byte data
* Return Value : None
********************************************************************************/
void R_UART1_Send_Byte(int8_t data) 
{ 
	if ((SRIF1) && (SSR01 != 0))        /* if any error in status register */
	{ 
		SRIF1 = 0;      				/* clear error interrupt request flag */ 
		SIR01 |= (SSR01&0x000F);
	} 

	TXD1 = data;     					/* load character to transmit register */
//	while (STIF1 == 0)					/* wait while transmission in progress */
//	{
//	}
	STIF1 = 0;       					/* clear transmission interrupt request flag */
}

/********************************************************************************
* Function Name: UART0_Send_String
* Description  : This function sends UART0 data string.
* Arguments    : data - 
*					string buffer
* Return Value : None
********************************************************************************/
void R_UART1_Send_String(__far int8_t buffer[]) 
{ 
	int8_t i;
	
	for (i = 0; buffer[i] != 0; i++)
	{
		R_UART1_Send_Byte(buffer[i]); 
	}
}

//int calcrc(char *ptr, int count)
