/******************************************************************************
*
* @file    $Name$
* @version $Revision$
* @date    $LastChangedDate$
*
* @Copyright 2015 - JIM.
*  This material is protected by copyright law. It is unlawful
*  to copy it.
*
* This document contains confidential information. It is not to be
* disclosed or used except in accordance with applicable contracts
* or agreements. This document must be rendered illegible when
* being discarded.
* 
* @remarks
* Modification History
* -------------------------
* See Version Control System History.
*
* @file This file contains the template class.
*
******************************************************************************/

#ifndef __USER_DEF_H__
#define __USER_DEF_H__

#ifdef __cplusplus
extern "C" {
#endif

/*****************************************************************************/
/*                              Include File                                 */
/*****************************************************************************/


/*****************************************************************************/
/*                      Global Macro or Enum Definition	                     */
/*****************************************************************************/
// Debug mode
#define FLASH_END_BLOCK         127		//R5F100xE, 100xG, 128K=127

// Release mode
//#define FLASH_END_BLOCK      	64

#define BOOT_AREA               0x1000
#define	FLASH_AREA              0x2200
//#define	FLASH_AREA              0x3000	//WangJin 2021.01.26
#define FLASH_BYTE_PER_BLOCK    0x400
//#define ROM_ADDRESS             (uint32_t)((FLASH_END_BLOCK*FLASH_BYTE_PER_BLOCK)-2)
//#define CHECKSUM_ADDRESS        (uint32_t)((FLASH_END_BLOCK*FLASH_BYTE_PER_BLOCK)-4)	WangJin 2021.01.26
//#define CHECKSUM_ADDRESS        0x3FFC//(uint32_t)((FLASH_END_BLOCK*FLASH_BYTE_PER_BLOCK)-4)
//#define CRC_ADDRESS        		(uint32_t)((FLASH_END_BLOCK*FLASH_BYTE_PER_BLOCK)-8)
//#define OTA_FLAG_ADDRESS        (uint32_t)((FLASH_END_BLOCK*FLASH_BYTE_PER_BLOCK)-4)

#define OTA_FLAG_END_ADDRESS    (uint32_t)((FLASH_END_BLOCK*(uint32_t)FLASH_BYTE_PER_BLOCK)-4) //0x1FBFC
#define OTA_FLAG_START_ADDRESS  (OTA_FLAG_END_ADDRESS - 4)	//0x1FBF8
#define CRC_ADDRESS        			(OTA_FLAG_START_ADDRESS - 4)	//0x1FBF4
// Debug mode
//#define FLASH_END_ADDRESS 0x0FBFF   // need to reserve last 512bytes and memory
                                      // per block is 0x400 = 1024 bytes, so,
                                      // 0xFFFF - 0x400  = 0xFC00 - 1 = 0xFBFF
        
#define FLASH_END_ADDRESS 			(uint32_t)((FLASH_END_BLOCK*FLASH_BYTE_PER_BLOCK)-1)//0x1FBFF
// Release mode
//#define FLASH_END_ADDRESS 0x0FFFF

#define FLASH_TABLE	0x4000



//#define FLASH_START_ADDRESS 0x2000 // 0x2000

/*****************************************************************************/
/*                   Global Structure or Union Definition     		         */
/*****************************************************************************/


/*****************************************************************************/
/*                       Global Variable Declaration                         */
/*****************************************************************************/


/*****************************************************************************/
/*                         Configuration Checking                            */
/*****************************************************************************/


/*****************************************************************************/
/*                       Global Function Declaration                         */
/*****************************************************************************/


#endif /* __TEMPLATE_H */
/* EOF */
